# Practicing Rust and WebAssembly

If you've stumbled on this repository, welcome! It's just not a code library or
anything, just a collection of small toy programs that I've either copied or
implemented to understand better how Rust and Web Assembly work. If you find it
useful, feel free to look around, but don't expect any eye-opening miracles.
It's just some code.

## rust-wasi-markdown

[rust-wasi-markdown](./rust-wasi-markdown) was the first thing implemented. It
demonstrates how a Wasmtime Engine is instantiated, how a Module is loaded, how
a Store is created, how an Import is created so that host functions can be
called from inside a running module, how an Instance takes the Module, Store,
and Import and creates a running instance, how functions from that Instance can
be located, and once located how they can be run.

Which is, what, 80% of eveything you need, right? Pareto principle and all that.


